/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.AttendanceTotalAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.KintaiApprovalPart;
import jp.mosp.common.part.KintaiCommonPart;

import jp.mosp.kintai.dao.MYukyuDao;
import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.dto.MYukyuDto;
import jp.mosp.kintai.vo.PaidHolidayCardVo;

public class PaidHolidayCardAction extends AttendanceTotalAction {

	// コマンド
	private static final String CMD_YUKYU_PERSONAL_SHOW   	= "K1300";	// 表示

	/**
	 * コンストラクタ
	 */
	public PaidHolidayCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		PaidHolidayCardVo vo = new PaidHolidayCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.clearMessage();
		vo.clearErrField();
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DBコネクション取得
		getConnection();
		// DTOの取得
		MYukyuDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MYukyuDto ? (MYukyuDto)obj : null;
		vo.setParams(request);
		// コマンド毎の処理
		if (cmd.equals(CMD_YUKYU_PERSONAL_SHOW)) {
			// 表示
			show(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 有休管理情報
	 * @param vo YukyuPersonalCardVoインスタンス
	 * @throws Exception
	 */
	private void show(PaidHolidayCardVo vo) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		vo.setDefaultValues();
		// ユーザー情報取得  社員コード摂取
		getInfo(user.getUserId());
		// 選択情報の設定
		// DAO準備
		MYukyuDao dao = new MYukyuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 対象年月を取得
		Date calcPayment = getCalcPayment();
		// 対象年月の前月の有給情報を取得
		// 対象年月の承認・未承認件数作成
		makeApprovalYukyuNumber(vo, calcPayment);
		// 対象年月の追加・廃棄予定作成
		makeAddAndDispose(mKihon.getKCode(), vo, util.addMonth(calcPayment , -1), calcPayment);
		// 有休情報のチェック
		// VOに情報を設定
		vo.setLblAttendanceCalcY(String.valueOf(MospUtility.getYear(calcPayment)));
		vo.setLblAttendanceCalcM(String.valueOf(MospUtility.getMonth(calcPayment)));
	}

	/**
	 * 有休承認・未承認件数作成
	 * @param vo
	 * @param targetDate
	 * @throws Exception
	 */
	private void makeApprovalYukyuNumber(PaidHolidayCardVo vo, Date targetDate) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// 勤怠集計対象月の出勤簿の取得
		getAttendanceList(mKihon.getKCode(), targetDate);
		// 勤怠情報設定
		setCalcParam();
		// データ数取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(MospUtility.getDate(startDate));
		int count = 0;
		while (MospUtility.getDate(endDate).compareTo(cal.getTime()) >= 0) {
			cal.add(Calendar.DAY_OF_MONTH, 1);
			count++;
		}
		// 配列初期化
		double number[] = {0.0, 0.0};
		// 出勤簿日集計データ
		Iterator<MSyukkinboDto> it = attendanceList.iterator();
		while (it.hasNext()) {
			// 日付設定
			cal.setTime(MospUtility.getDate(startDate));
			MSyukkinboDto dto = it.next();
			Date attendanceDate = MospUtility.getDate(dto.getHizuke());
			// 日数データ件数分繰り返す
			for (int i = 0; i < count; i++) {
				if (attendanceDate.compareTo(cal.getTime()) == 0) {
					// 有休休暇
					if (KintaiCommonPart.isHoliday(dto)) {
						if (dto.getKKRiyuu().equals(aryHolidayReason[0][0])) {
							// 承認、未承認数
							if (KintaiApprovalPart.is2ndApproved(dto)) {
								number[0]++;
							} else {
								number[1]++;
							}
						}
					}
					// 半休
					else if (KintaiCommonPart.isStartHalfHoliday(dto) 
							|| KintaiCommonPart.isQuitHalfHoliday(dto)
					) {
						// 承認、未承認数
						if (KintaiApprovalPart.is2ndApproved(dto)) {
							number[0] += 0.5;
						} else {
							number[1] += 0.5;
						}
					}
					break;
				}
				cal.add(Calendar.DAY_OF_MONTH, 1);			
			}
		}
		// VOに情報を設定
		vo.setLblApproved(String.valueOf(number[0]));
		vo.setLblRemainApproved(String.valueOf(number[1]));
	}

	/**
	 * 有休追加・廃棄件数作成
	 * @param kCode				
	 * @param vo				
	 * @param formerCalcPayment	
	 * @param calcPayment		
	 * @throws Exception
	 */
	private void makeAddAndDispose(
			String kCode,
			PaidHolidayCardVo vo,
			Date formerCalcPayment,
			Date calcPayment
	) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// 繰越月
		int CFMonth = Integer.parseInt(getPaidHolidayInfo()[0]);
		// 繰越日数
		int CFDays = Integer.parseInt(getPaidHolidayInfo()[1]);
		// 繰越区分
		String CFFlag = getPaidHolidayInfo()[2];
		// パラメータの初期化
		// 当月残日数（当年度分）
		double remainLastThis = 0;
		// 当月残日数（前年度分）
		double remainLastPrev = 0;
		// 使用日数
		double use = 0;
		// 支給日数
		int payment = 0;
		// 破棄日数
		double waste = 0;
		// 来月有休予定数（当年度分）
		double remainThisThis = 0;
		// 来月有休予定数（前年度分）
		double remainThisPrev = 0;	
		// DAOの準備
		MYukyuDao 	mYukyuDao 	= new MYukyuDao();
		mYukyuDao.initDao(cfg, cmd, aspUser, user, conn);
		// 当月の有給情報検索
		String Date = util.convDateToString(calcPayment);
		MYukyuDto currentDto = mYukyuDao.findForKey(kCode, Date);
		if (!chkExistDto(currentDto)) {
			currentDto = new MYukyuDto();
			currentDto.setKCode(kCode);
			currentDto.setKyuyoYMD(Integer.parseInt(Date));
		}
		String formerDate  = util.convDateToString(formerCalcPayment);
		MYukyuDto formerDto = mYukyuDao.findForFormer(kCode, formerDate);
		if (!chkExistDto(formerDto)) {
			formerDto = new MYukyuDto();
		}
		/*						
		 *  	2008/11/07	m.yoshida	使用日数を設定していなかったため。
		 */
		// 承認済有休数を使用日数にセットする。
		use = vo.getDoubleParam(vo.getLblApproved());
		// 前月の有給情報の設定
		remainLastThis = formerDto.getTZanT();
		remainLastPrev = formerDto.getTZanZ();
		if (CFMonth == MospUtility.getMonth(calcPayment)) {
			// 繰り越し区分判別
			// 当年のみ
			if (CFFlag.equals(CommonConst.NAM_COMMON_FLAG_OFF)) {
				// 廃棄更新
				// 前々年度分を消化数を引いた分破棄。
				if (remainLastPrev < use) {
					use = Math.abs(remainLastPrev - use);
					waste = 0;
				} else {
					waste = remainLastPrev - use;
					use = 0;
				}
				// 前月前年度分を当月前年度分に移動。
				remainThisPrev = remainLastThis;
			}
			// 合計で繰り越し
			else if (CFFlag.equals(CommonConst.NAM_COMMON_FLAG_ON)) {
				// 前月分を合計して繰越日数分だけ繰り越す。
				if ((remainLastPrev + remainLastThis) >= CFDays) {
					waste = (remainLastPrev + remainLastThis) - CFDays;
				} else {
					waste = 0;
				}
				remainThisPrev = remainLastPrev + remainLastThis - waste;
			}
			// 勤続月数取得
			double yearOfService = getYearsOfService(kCode);
			// 勤続月数から有給支給日数を取得
			String[][] aryPaidHolidayDays = getPaidHolidayArray();
			for (int i = 0; i < aryPaidHolidayDays.length; i++) {
				if (yearOfService >= Integer.parseInt(aryPaidHolidayDays[i][0])) {
					payment = Integer.parseInt(aryPaidHolidayDays[i][1]);
				}
			}
			remainThisThis += payment;
			//有給更新
			if (use <= remainThisPrev) {
				remainThisPrev -= use;
			} else {
				// 当月消化分
				use -= remainThisPrev;
				remainThisPrev = 0;
				remainThisThis -= use;
			}				
		} else {
			//有給取得更新
			remainThisThis += remainLastThis;
			remainThisPrev += remainLastPrev;
			//有給更新
			if (use <= remainThisPrev) {
				remainThisPrev -= use;
			} else {
				// 当月消化分
				use -= remainThisPrev;
				remainThisPrev = 0;
				remainThisThis -= use;
			}
		}
		// VOに情報を設定
		vo.setLblThisMGet(String.valueOf(payment));
		vo.setLblThisMDispose(String.valueOf(waste));
		vo.setLblThisMRestLY(String.valueOf(remainThisPrev));
		vo.setLblThisMRestTY(String.valueOf(remainThisThis));
		vo.setLblPaidHolidayLY(String.valueOf(remainLastPrev));
		vo.setLblPaidHolidayTY(String.valueOf(remainLastThis));
	}

}
